package rpc

import (
	"log"
)

type DiscoveryService struct {
}

type StartRequestParam struct {
	Name  string
	Count int
}

type StartResponseParam struct {
	Result int
}

// func (ds *DiscoveryService) Start(req *StartRequestParam) (*StartResponseParam, error) {
// 	log.Printf("DiscoveryService.Start param: Name[%s] Count[%d]", req.Name, req.Count)
// 	res := &StartResponseParam{}

// 	res.Result = 10 + req.Count

// 	return res, nil
// }

// func (ds *DiscoveryService) Discovery(name string, req *StartRequestParam) error {
// 	log.Printf("DiscoveryService.Discovery param: Name[%s] req[%v]", name, req)

// 	return nil
// }

// func (ds *DiscoveryService) Discovery1(count int, name string, req *StartRequestParam) error {
// 	log.Printf("DiscoveryService.Discovery param: Count[%d] Name[%s] req[%v]", count, name, req)

// 	return nil
// }

func (ds *DiscoveryService) Discovery2(count int, name string, req *StartRequestParam) (*StartResponseParam, error) {
	log.Printf("DiscoveryService.Discovery2 param: count[%d] name[%s] req.Name[%s] req.Count[%d]", count, name, req.Name, req.Count)
	res := &StartResponseParam{}

	res.Result = 10 + req.Count

	return res, nil
}

func (ds *DiscoveryService) Discovery3(names []string, req *StartRequestParam) (*StartResponseParam, error) {
	log.Printf("DiscoveryService.Discovery3 param: names[%v] req.Name[%s] req.Count[%d]", names, req.Name, req.Count)
	res := &StartResponseParam{}

	res.Result = 10 + req.Count

	return res, nil
}

func (ds *DiscoveryService) Discovery4(names map[string]string, req *StartRequestParam) (*StartResponseParam, error) {
	log.Printf("DiscoveryService.Discovery4 param: names[%v] req.Name[%s] req.Count[%d]", names, req.Name, req.Count)
	res := &StartResponseParam{}

	res.Result = 10 + req.Count

	return res, nil
}
